﻿using Microsoft.AspNetCore.Mvc;
using Polly;

// For more information on enabling Web API for empty projects, visit https://go.microsoft.com/fwlink/?LinkID=397860

namespace PollyNet6PolicyDIToController.Controllers
{
    [Route("[controller]")]
    [ApiController]
    public class CatalogController : ControllerBase
    {
        private readonly IAsyncPolicy<HttpResponseMessage> _policy;
        public CatalogController(IAsyncPolicy<HttpResponseMessage> policy)
        {
            _policy = policy;
        }

        [HttpGet("{id}")]
        public async Task<IActionResult> Get(int id)
        {
            HttpClient httpClient = new HttpClient();
            httpClient.BaseAddress = new System.Uri(@"http://localhost:5000/");
            string requestEndpoint = $"inventory/{id}";

            HttpResponseMessage response = await _policy.ExecuteAsync(() => httpClient.GetAsync(requestEndpoint));

            if (response.IsSuccessStatusCode)
            {
                var itemsInStock = await response.Content.ReadAsStringAsync();
                return Ok(itemsInStock);
            }

            return StatusCode((int)response.StatusCode, response.Content.ReadAsStringAsync());
        }
    }
}
